## elog 3.1.2-1

=== debian/changelog ===
elog (3.1.2-1-1+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload by the LTS team.
  * Add patch to fixed NULL pointer deference in
    show_uploader_json. (Fixes: CVE-2020-8659)

 -- Utkarsh Gupta <utkarsh@debian.org>  Wed, 18 May 2022 05:57:05 +0530

elog (3.1.2-1-1) unstable; urgency=low

  * new upstream version grabbed, (Closes: #836505, CVE-2016-6342)
  * update debian/rules
    - allow reproducible builds (Closes: #816209)
    - enable all hardening build flags
  * update debian/source/lintian-overrides for contrib/elogsubmit.js
    insane-line-length-in-source-file, removed unused overrides
  * update Standards-Version to 3.9.8 (debian/control)

 -- Roger Kalt <roger.kalt@gmail.com>  Tue, 06 Sep 2016 20:00:00 +0100

=== debian/control ===
Source: elog
Section: web
Priority: optional
Maintainer: Roger Kalt <roger.kalt@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libssl-dev, libkrb5-dev
Standards-Version: 3.9.8
Homepage: http://midas.psi.ch/elog

Package: elog
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, net-tools, libjs-jquery
Recommends: imagemagick, ckeditor
Description: Logbook system to manage notes through a Web interface
 The Electronic Logbook (ELOG) provides a Web interface to manage notes.  Its
 general purpose is to make it easy for people to put and access information
 online; in the form of short, time stamped text messages with optional HTML
 markup for presentation, and optional file attachments.  ELOG has its own
 daemon, there is no need for a full-fledged server (e.g. Apache).  It stores
 notes as simple as plain text; no special formatting.  Its features:
 .
   * Personal logbooks: Personal notes can be written into ELOG and can then be
     retrieved from anywhere with a Web browser.
   * Shared logbooks: Logbooks can be shared by several people, for reading and
     optionally for writing.  Work groups can share and exchange information
     like in a (simplified) news group.
   * Small databases: Since arbitrary attributes can be defined for a logbook,
     it can be used as a small database with search facilities.
   * Problem collections: A system can consist of two logbooks, in one of which
     users enter bugs or problems.  Whenever someone adds a problem, an email
     is automatically sent to the administrator.
   * Shift logbooks: If the Allow delete and Allow edit flags are off, an entry
     cannot be modified once it's been entered.  This can be useful for shift
     logbooks for example in Physics experiments where each entry becomes a
     "document" with a time and author stamp.
   * File collections: Since files can be attached to ELOG entries, the system
     can be used to store and retrieve files.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2003, 2006  Recai Oktaş <roktas@omu.edu.tr>
# Copyright (c) 2014 Roger Kalt <roger.kalt@gmail.com>
# Portions are based on the sample debian/rules of debhelper.
#
# Licensed under the GNU General Public License, version 2.
# See the file `http://www.gnu.org/copyleft/gpl.txt'.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all


# A few convenience variables.
NAME=elog
SRCDIR=$(shell pwd)
DESTDIR=$(shell pwd)/debian/$(NAME)
CONFDIR=etc
DATADIR=usr/share/$(NAME)
VARDIR=var/lib/$(NAME)
DOCDIR=usr/share/doc/$(NAME)
SRVDIR=$(VARDIR)

CFLAGS = `dpkg-buildflags --get CFLAGS`
CFLAGS += -funroll-loops -fomit-frame-pointer -W -Wall -Wl,-z,relro -D_FORTIFY_SOURCE=2 
LDFLAGS = `dpkg-buildflags --get LDFLAGS`
LDFLAGS += defs

# Enable by default OpenSSL and KRB5 support in the Debian binaries
LIBS= -lkrb5 -lssl

# User CFLAGS
CFLAGS += -DHAVE_KRB5 \
	  -DHAVE_SSL \
	  -DUSE_CRYPT \
	  -DDEFAULT_PORT=80 \
	  -DCFGFILE=\"elog.conf\" \
          -DCONFIG_PATH=\"/$(CONFDIR)\" \
	  -DLOGBOOK_DIR=\"/$(SRVDIR)/logbooks\" \
	  -DRESOURCE_DIR=\"/$(DATADIR)\"


build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:
	dh_testdir
	# Compile with the standard crypt support.
	cd $(SRCDIR); $(MAKE) CFLAGS='$(CFLAGS)' LIBS='$(LIBS)'
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	-cd $(SRCDIR); $(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/elog install

# Build architecture-independent files here.
binary-indep: install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs -X doc/ChangeLog $(SRCDIR)/doc/
	# not installing the very old html pages located here: $(SRCDIR)/doc/
	# Fix 'doc/doc'; 'doc/html' is more usual.
	-cd $(DESTDIR)/$(DOCDIR); mv doc html
	# Remove contrib content and install new README with download location of external contributions
	# Reason: Too many different authors with too many different licenses: Should stay external of Debian
	mkdir -p $(DESTDIR)/$(DOCDIR)/contrib
	printf "Download external elog contributions here: https://midas.psi.ch/elogs/Contributions/" > $(DESTDIR)/$(DOCDIR)/contrib/README
	dh_installchangelogs $(SRCDIR)/doc/ChangeLog
	dh_installexamples debian/examples/*
	dh_installman $(SRCDIR)/man/*
	# install empty ssl directoy and skip the server.crt / server.key from orig sources
	mkdir -p $(DESTDIR)/usr/share/elog/ssl
	printf "In case SSL is enabled in '/etc/elog.conf' make here manually the following symbolic links:\n   ./server.key -> /etc/ssl/private/my.key\n   ./server.crt -> /etc/ssl/certs/my.pem\n\nGeneration of self-signed SSL certificates can e.g. be done easily with command /usr/sbin/make-ssl-cert from package ssl-cert." > $(DESTDIR)/usr/share/elog/ssl/README
	dh_lintian
	# install the init script but do not modify the postinst, prerm and postrm scripts
	dh_installinit --noscripts
	dh_install
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

# Get most current orig source from PSI ELOG FTP server and do the repacking automatically.
# The ORIG_VERSION must be set manually.
ORIG_VERSION=3.1.2-1
get-orig-source:
	wget -q http://midas.psi.ch/elog/download/tar/elog-$(ORIG_VERSION).tar.gz
	tar xzf ./elog-$(ORIG_VERSION).tar.gz
	# rename elog folder
	mv ./elog-3.1.2 ./elog-$(ORIG_VERSION)
	# move mxml/* into elog/src
	mv ./mxml/* ./elog-$(ORIG_VERSION)/src
	# delete embedded source of CKeditor coming from upstream
	rm -rf ./elog-$(ORIG_VERSION)/scripts/ckeditor
	rm -rf ./elog-$(ORIG_VERSION)/scripts/ckeditor.zip
	# delete embedded jquery coming from upstream
	rm -rf ./elog-$(ORIG_VERSION)/scripts/jquery-1.11.1.min.js
	# remove compressed javacript of progress bar, fetch progress bar javascript sources and embed it
	rm -rf ./elog-$(ORIG_VERSION)/scripts/progress/*
	wget -q https://github.com/usablica/progress.js/archive/v0.1.0.tar.gz
	tar xzf v0.1.0.tar.gz
	cp progress.js-0.1.0/README.md ./elog-$(ORIG_VERSION)/scripts/progress/
	cp progress.js-0.1.0/src/* ./elog-$(ORIG_VERSION)/scripts/progress/
	# pack it
	cd ..
	tar czf ../../$(shell date "+%Y%m%d-%H%M%S")-REPACKED-elog_$(ORIG_VERSION).orig.tar.gz --exclude-vcs -C ./ elog-$(ORIG_VERSION)
	rm -rf ./elog-$(ORIG_VERSION).tar.gz ./mxml ./v0.1.0.tar.gz ./progress.js-0.1.0 ./elog-$(ORIG_VERSION)

.PHONY: build clean binary-indep binary-arch binary install

## elog 3.1.3

=== Makefile ===
# Simple makefile for elogd
#
# S. Ritt, May 12th 2000
# install/clean section by Th. Bullinger, Apr. 26th, 2002
#############################################################

#
# Directories for installation, modify if needed
#

ifndef PREFIX
PREFIX     = /usr/local
endif

ifndef MANDIR
MANDIR     = $(ROOT)$(PREFIX)/man
endif

ELOGDIR    = $(ROOT)$(PREFIX)/elog
DESTDIR    = $(ROOT)$(PREFIX)/bin
SDESTDIR   = $(ROOT)$(PREFIX)/sbin
RCDIR      = $(ROOT)/etc/rc.d/init.d

# flag for SSL support
USE_SSL    = 1

# flag for Kerberos support, please turn on if you need Kerberos
USE_KRB5   = 0

# flag for LDAP support, please turn on if you need LDAP
USE_LDAP   = 0

#############################################################

# Default compilation flags unless stated otherwise.
CFLAGS += -O3 -funroll-loops -fomit-frame-pointer -W -Wall -Wno-deprecated-declarations -Imxml

CC = gcc
IFLAGS = -kr -nut -i3 -l110
EXECS = elog elogd elconv
OBJS = mxml.o crypt.o regex.o
GIT_REVISION = src/git-revision.h
BINOWNER = bin
BINGROUP = bin

# Option to use our own implementation of strlcat, strlcpy
NEED_STRLCPY = 1

INSTALL = `which install`
RM = /bin/rm -f

OSTYPE = $(shell uname)

ifeq ($(OSTYPE),SunOS)
CC = gcc
LIBS += -lsocket -lnsl
CFLAGS =
INSTALL = /usr/ucb/install
RM = /usr/bin/rm -f
endif

ifeq ($(OSTYPE),OpenBSD)
LIBS += -lcrypto
endif

ifeq ($(OSTYPE),Darwin)
OSTYPE=darwin
endif

ifeq ($(OSTYPE),darwin)
CC = cc
BINOWNER = root
BINGROUP = admin
NEED_STRLCPY =
CFLAGS += -I/opt/local/include
endif

ifeq ($(OSTYPE),FreeBSD)
CC = gcc
BINOWNER = root
BINGROUP = wheel
endif

ifeq ($(OSTYPE),Linux)
CC = gcc
endif

ifdef USE_SSL
ifneq ($(USE_SSL),0)
CFLAGS += -DHAVE_SSL
LIBS += -lssl
endif
endif

ifdef USE_KRB5
ifneq ($(USE_KRB5),0)
CFLAGS += -DHAVE_KRB5
LIBS += -lkrb5
endif
endif

ifdef USE_LDAP
ifneq ($(USE_LDAP),0)
CFLAGS += -DHAVE_LDAP
LIBS += -lldap
endif
endif

ifdef NEED_STRLCPY
OBJS += strlcpy.o
endif

WHOAMI = $(shell whoami)
ifeq ($(WHOAMI),root)
BINFLAGS = -o ${BINOWNER} -g ${BINGROUP}
endif

all: $(EXECS)

# put current GIT revision into header file to be included by programs
$(GIT_REVISION): src/elogd.c src/elog.c
	type git &> /dev/null; if [ $$? -eq 1 ]; then REV="unknown" ;else REV=`git log -n 1 --pretty=format:"%ad - %h"`; fi; echo \#define GIT_REVISION \"$$REV\" > $(GIT_REVISION)

regex.o: src/regex.c src/regex.h
	$(CC) $(CFLAGS) -w -c -o regex.o src/regex.c

crypt.o: src/crypt.c
	$(CC) $(CFLAGS) -w -c -o crypt.o src/crypt.c

auth.o: src/auth.c
	$(CC) $(CFLAGS) -w -c -o auth.o src/auth.c

mxml.o: mxml/mxml.c mxml/mxml.h
	$(CC) $(CFLAGS) -c -o mxml.o mxml/mxml.c

strlcpy.o: mxml/strlcpy.c mxml/strlcpy.h
	$(CC) $(CFLAGS) -c -o strlcpy.o mxml/strlcpy.c

elogd: src/elogd.c auth.o $(OBJS) $(GIT_REVISION)
	$(CC) $(CFLAGS) -o elogd src/elogd.c auth.o $(OBJS) $(LIBS)

elog: src/elog.c $(OBJS) $(GIT_REVISION)
	$(CC) $(CFLAGS) -o elog src/elog.c $(OBJS) $(LIBS)

debug: src/elogd.c auth.o $(OBJS)
	$(CC) -g $(CFLAGS) -O0 -o elogd src/elogd.c auth.o $(OBJS) $(LIBS)

%: src/%.c
	$(CC) $(CFLAGS) -o $@ $< $(LIBS)

indent:
	for src in src/*.c; do \
		d2u $$src; \
		indent $(IFLAGS) $$src; \
		u2d $$src; \
	done

ifeq ($(OSTYPE),CYGWIN_NT-5.1)
loc: locext.exe
	for lang in resources/eloglang*; do \
	  ./locext.exe src/elogd.c $$lang; echo locext src/elogd.c $$lang;\
	done
else
locext: src/locext.c
loc: locext
	@for lang in resources/eloglang*; do \
	  ./locext src/elogd.c $$lang; echo locext src/elogd.c $$lang;\
	done
endif

update: $(EXECS)
	@$(INSTALL) -v -m 0755 ${BINFLAGS} elogd $(SDESTDIR)

install: $(EXECS)
	@$(INSTALL) -m 0755 -d $(DESTDIR) $(SDESTDIR) $(MANDIR)/man1/ $(MANDIR)/man8/
	@$(INSTALL) -m 0755 -d $(ELOGDIR)/scripts/ $(ELOGDIR)/resources/ $(ELOGDIR)/ssl/ $(ELOGDIR)/themes/default/icons
	@$(INSTALL) -m 0755 -d $(ELOGDIR)/logbooks/demo
	@$(INSTALL) -m 0755 -d $(ELOGDIR)/logbooks/demo/2001
	@$(INSTALL) -v -m 0755 ${BINFLAGS} elog elconv $(DESTDIR)
	@$(INSTALL) -v -m 0755 ${BINFLAGS} elogd $(SDESTDIR)
	@$(INSTALL) -v -m 0644 man/elog.1 man/elconv.1 $(MANDIR)/man1/
	@$(INSTALL) -v -m 0644 man/elogd.8 $(MANDIR)/man8/
	@$(INSTALL) -v -m 0644 scripts/*.js $(ELOGDIR)/scripts/

	@echo "Installing CKeditor to $(ELOGDIR)/scripts/ckeditor"
	@cp -r scripts/* $(ELOGDIR)/scripts

	@echo "Installing resources to $(ELOGDIR)/resources"
	@$(INSTALL) -m 0644 resources/* $(ELOGDIR)/resources/
	@if [ ! -f $(ELOGDIR)/ssl/server.crt ]; then  \
	  $(INSTALL) -v -m 0644 ssl/server.crt $(ELOGDIR)/ssl/ ;\
	fi
	@if [ ! -f $(ELOGDIR)/ssl/server.key ]; then  \
	  $(INSTALL) -v -m 0644 ssl/server.key $(ELOGDIR)/ssl/ ;\
	fi

	@echo "Installing themes to $(ELOGDIR)/themes"
	@cp -r themes/* $(ELOGDIR)/themes

	@echo "Installing example logbook to $(ELOGDIR)/logbooks/demo"
	@if [ ! -f $(ELOGDIR)/logbooks/demo/2001 ]; then  \
	  $(INSTALL) -v -m 0644 logbooks/demo/2001/* $(ELOGDIR)/logbooks/demo/2001 ; \
	fi

	@if [ ! -f $(ELOGDIR)/elogd.cfg ]; then  \
	  $(INSTALL) -v -m 644 elogd.cfg $(ELOGDIR)/elogd.cfg ; \
	fi

ifeq ($(OSTYPE),darwin)
	@$(INSTALL) -v -m 0644 elogd.plist /Library/LaunchDaemons/ch.psi.elogd.plist
	@echo The elogd service can now be started with 
	@echo "  sudo launchctl load /Library/LaunchDaemons/ch.psi.elogd.plist"
else
	@sed "s#\@PREFIX\@#$(PREFIX)#g" elogd.init_template > elogd.init
	@if [ ! -f $(RCDIR)/elogd ]; then  \
	  $(INSTALL) -v -m 0755 -D elogd.init $(RCDIR)/elogd ; \
	fi
endif

restart:
	$(RCDIR)/elogd restart
clean:
	-$(RM) *~ $(EXECS) regex.o crypt.o auth.o mxml.o strlcpy.o locext

## elog 3.1.3-1

=== debian/changelog ===
elog (3.1.3-1-1build2) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Wed, 01 Dec 2021 12:04:59 +0100

elog (3.1.3-1-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 23:21:23 +0000

elog (3.1.3-1-1) unstable; urgency=medium

  * new upstream version grabbed
  * debian/
     - updated debian/source/lintian-overrides to fix lintian report
     - updated debian/rules to apply hardening flags correctly
     - updated Standards-version to 4.0.0 (debian/control)
     - updated debian/patches/* to work with new upstream version
     - removed 0002_html_doc.patch because fixed in upstream

 -- Roger Kalt <roger.kalt@gmail.com>  Sun, 11 Jun 2017 22:04:06 +0200

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,10 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+
 
 
 # A few convenience variables.
@@ -21,10 +24,14 @@
 DOCDIR=usr/share/doc/$(NAME)
 SRVDIR=$(VARDIR)
 
-CFLAGS = `dpkg-buildflags --get CFLAGS`
+#CFLAGS = `dpkg-buildflags --get CFLAGS`
+CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
 CFLAGS += -funroll-loops -fomit-frame-pointer -W -Wall -Wl,-z,relro -D_FORTIFY_SOURCE=2 
-LDFLAGS = `dpkg-buildflags --get LDFLAGS`
+CFLAGs += -g -O2 -fPIE -fstack-protector-strong -Wformat -Werror=format-security
+#LDFLAGS = `dpkg-buildflags --get LDFLAGS`
+LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
 LDFLAGS += defs
+LDFLAGs += -fPIE -pie -Wl,-z,relro -Wl,-z,now
 
 # Enable by default OpenSSL and KRB5 support in the Debian binaries
 LIBS= -lkrb5 -lssl
@@ -102,14 +109,15 @@
 
 # Get most current orig source from PSI ELOG FTP server and do the repacking automatically.
 # The ORIG_VERSION must be set manually.
-ORIG_VERSION=3.1.2-1
+ORIG_VERSION=3.1.3-1
 get-orig-source:
 	wget -q http://midas.psi.ch/elog/download/tar/elog-$(ORIG_VERSION).tar.gz
 	tar xzf ./elog-$(ORIG_VERSION).tar.gz
 	# rename elog folder
-	mv ./elog-3.1.2 ./elog-$(ORIG_VERSION)
-	# move mxml/* into elog/src
-	mv ./mxml/* ./elog-$(ORIG_VERSION)/src
+	mv ./elog-3.1.3 ./elog-$(ORIG_VERSION)
+	# move mxml/* into elog/src and delete source folder
+	mv ./elog-$(ORIG_VERSION)/mxml/* ./elog-$(ORIG_VERSION)/src
+	rm -rf ./elog-$(ORIG_VERSION)/mxml
 	# delete embedded source of CKeditor coming from upstream
 	rm -rf ./elog-$(ORIG_VERSION)/scripts/ckeditor
 	rm -rf ./elog-$(ORIG_VERSION)/scripts/ckeditor.zip
@@ -123,7 +131,7 @@
 	cp progress.js-0.1.0/src/* ./elog-$(ORIG_VERSION)/scripts/progress/
 	# pack it
 	cd ..
-	tar czf ../../$(shell date "+%Y%m%d-%H%M%S")-REPACKED-elog_$(ORIG_VERSION).orig.tar.gz --exclude-vcs -C ./ elog-$(ORIG_VERSION)
-	rm -rf ./elog-$(ORIG_VERSION).tar.gz ./mxml ./v0.1.0.tar.gz ./progress.js-0.1.0 ./elog-$(ORIG_VERSION)
+	tar czf ../$(shell date "+%Y%m%d-%H%M%S")-REPACKED-elog_$(ORIG_VERSION).orig.tar.gz --exclude-vcs -C ./ elog-$(ORIG_VERSION)
+	rm -rf ./elog-$(ORIG_VERSION).tar.gz ./v0.1.0.tar.gz ./progress.js-0.1.0 ./elog-$(ORIG_VERSION)
 
 .PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
# See uscan(1) for format

version=3
opts=dversionmangle=s/\+dfsg// \
http://midas.psi.ch/elog/download/tar/elog-(\d\S*)\.tar\.gz
